//nolint:goconst
package main

import (
	"fmt"
	"os"
	"sort"
)

func writeCharacteristic(cc []Characteristic) error {
	f, err := os.Create("hapip/characteristic/apple_characteristic_gen.go")
	if err != nil {
		return err
	}
	defer f.Close()

	_, err = f.WriteString(`// Code generated by cmd/generate/main.go; DO NOT EDIT.

package characteristic
`)
	if err != nil {
		return err
	}

	for _, c := range cc {
		txt := makeCharacteristic(c)
		_, err = f.WriteString(txt)
		if err != nil {
			return err
		}
	}

	if err = f.Close(); err != nil {
		return err
	}
	return nil
}

type perms struct {
	read, write, notify bool
}

var readOnly = perms{read: true}
var readNotify = perms{read: true, notify: true}
var readWriteNotify = perms{read: true, write: true, notify: true}
var writeOnly = perms{write: true}
var readWrite = perms{read: true, write: true}

func parsePerms(ss []string) perms {
	var p perms
	for _, s := range ss {
		switch s {
		case "read":
			p.read = true
		case "write":
			p.write = true
		case "cnotify":
			p.notify = true

		case "uncnotify":
		default:
			panic(s)
		}
	}
	return p
}

func makeCharacteristic(c Characteristic) string {
	if c.Format == "tlv8" {
		return makeTLV8Characteristic(c)
	}
	inType := goType(c.Format)
	outType := inType
	funcName := camelCase(c.Name)
	txt := "\n"

	// add valid values as const
	if len(c.Constraints.ValidBits) > 0 {
		if len(c.Constraints.ValidValues) > 0 {
			panic("both ValidBits and ValidValues are set for " + c.UUID)
		}
		c.Constraints.ValidValues = make(map[string]string, len(c.Constraints.ValidBits))
		for k, v := range c.Constraints.ValidBits {
			c.Constraints.ValidValues["1 << "+k] = v
		}
	}
	if values := c.Constraints.ValidValues; len(values) > 0 {
		inType = funcName + "_Type"
		txt += "type " + inType + " " + outType + "\n\n"
		keys := make([]string, 0, len(values))
		for k := range values {
			keys = append(keys, k)
		}
		sort.Strings(keys)
		for _, k := range keys {
			txt += "const " + funcName + "_" + camelCase(values[k]) + " = " + inType + "(" + k + ")\n"
		}
		txt += "\n"
	}

	txt += metaVar(c, funcName, outType)
	txt += "\n// " + funcName + " represents a " + c.Name + " characteristic (" + shortUUID(c.UUID) + ")\n"
	txt += "//\n"
	txt += "// UUID: " + c.UUID + ".\n"

	p := parsePerms(c.Properties)
	switch p {
	case readOnly:
		txt += "func " + funcName + "(value " + inType + ") Static[" + outType + "] {\n"
		txt += staticVar(funcName, inType, outType)
		txt += "	return static\n"
		txt += "}\n"
	case readNotify:
		txt += "func " + funcName + "(value " + inType + ") *Updatable[" + outType + "] {\n"
		txt += staticVar(funcName, inType, outType)
		txt += "	return &Updatable[" + outType + "]{\n"
		txt += "		Static: static,\n"
		txt += "	}\n"
		txt += "}\n"
	case readWriteNotify, readWrite: // readWrite doesn't need the notify capability
		txt += "func " + funcName + "(value " + inType + ", controllerWrite func(" + outType + ") error) *Writable[" + outType + "] {\n"
		txt += staticVar(funcName, inType, outType)
		txt += "	return &Writable[" + outType + "]{\n"
		txt += "		Updatable: Updatable[" + outType + "]{Static: static},\n"
		txt += "		write: controllerWrite,\n"
		txt += "	}\n"
		txt += "}\n"
	case writeOnly:
		txt += "func " + funcName + "(controllerWrite func(" + outType + ") error) WriteOnly[" + outType + "] {\n"
		txt += "	return WriteOnly[" + outType + "]{\n"
		txt += "		Metadata: " + funcName + "_Meta,\n"
		txt += "		write:    controllerWrite,\n"
		txt += "	}\n"
		txt += "}\n"
	default:
		fmt.Printf("UNSUPPORTED PERMISSIONS: %#v\n", p)
		panic(p)
	}

	return txt
}

func makeTLV8Characteristic(c Characteristic) string {
	// inType := goType(c.Format)
	funcName := camelCase(c.Name)
	respType := funcName + "Response"
	reqType := funcName + "Request"
	txt := "\n"

	txt += "\n// " + funcName + " represents a " + c.Name + " characteristic (" + shortUUID(c.UUID) + ")\n"
	txt += "//\n"
	txt += "// UUID: " + c.UUID + ".\n"

	p := parsePerms(c.Properties)
	switch p {
	case readOnly:
		txt += "func " + funcName + "(value " + respType + ") StaticTLV8[" + respType + "] {\n"
		txt += staticTLV8(respType, shortUUID(c.UUID))
		txt += "	return static\n"
		txt += "}\n"
	case readNotify:
		txt += "func " + funcName + "(value " + respType + ") *UpdatableTLV8[" + respType + "] {\n"
		txt += staticTLV8(respType, shortUUID(c.UUID))
		txt += "	return &UpdatableTLV8[" + respType + "]{\n"
		txt += "		StaticTLV8: static,\n"
		txt += "	}\n"
		txt += "}\n"
	case readWriteNotify, readWrite: // readWrite doesn't need the notify capability
		bothType := reqType + ", " + respType
		txt += "func " + funcName + "(value " + respType + ", controllerWrite func(" + reqType + ") (" + respType + ", error)) *WritableTLV8[" + bothType + "] {\n"
		txt += staticTLV8(respType, shortUUID(c.UUID))
		txt += "	return &WritableTLV8[" + bothType + "]{\n"
		txt += "		UpdatableTLV8: UpdatableTLV8[" + respType + "]{StaticTLV8: static},\n"
		txt += "		write: controllerWrite,\n"
		txt += "	}\n"
		txt += "}\n"
	case writeOnly:
		txt += "func " + funcName + "(controllerWrite func(" + reqType + ") error) WriteOnlyTLV8[" + reqType + "] {\n"
		txt += "	return WriteOnlyTLV8[" + reqType + "]{\n"
		txt += "		StaticTLV8: StaticTLV8[struct{}]{Typ: \"" + shortUUID(c.UUID) + "\"},\n"
		txt += "		write: controllerWrite,\n"
		txt += "	}\n"
		txt += "}\n"
	default:
		fmt.Println(c.Name)
		fmt.Printf("UNSUPPORTED PERMISSIONS: %#v\n", p)
		panic(p)
	}

	return txt
}

func staticTLV8(typ, uuid string) string {
	txt := ""
	txt += "	static := StaticTLV8[" + typ + "]{\n"
	txt += "		Typ:   \"" + shortUUID(uuid) + "\",\n"
	txt += "		value: value,\n"
	txt += "	}\n"
	return txt
}
func staticVar(funcName, inType, outType string) string {
	txt := ""
	txt += "	static := Static[" + outType + "]{\n"
	txt += "		Metadata: " + funcName + "_Meta,\n"
	if inType == outType {
		txt += "		value:    value,\n"
	} else {
		txt += "		value:    " + outType + "(value),\n"
	}
	txt += "	}\n"
	return txt
}
func metaVar(c Characteristic, funcName, outType string) string {
	txt := ""
	txt += "var " + funcName + "_Meta = Metadata[" + outType + "]{\n"
	txt += "	Typ: \"" + shortUUID(c.UUID) + "\",\n"
	if c.Unit != "" {
		txt += "	Unit: \"" + c.Unit + "\",\n"
	}
	if c.Constraints.MinimumValue != nil {
		txt += fmt.Sprintf("	MinValue: ValuePointer[%s](%v),\n", outType, c.Constraints.MinimumValue)
	}
	if c.Constraints.MaximumValue != nil {
		txt += fmt.Sprintf("	MaxValue: ValuePointer[%s](%v),\n", outType, c.Constraints.MaximumValue)
	}
	if c.Constraints.StepValue != nil {
		txt += fmt.Sprintf("	MinStep: %v,\n", c.Constraints.StepValue)
	}

	// TODO: other constraints: valid-values, valid-values-range, maxDataLen

	txt += "}\n"
	return txt
}

func goType(format string) string {
	switch format {
	case "bool":
		return "bool"
	case "uint8":
		return "uint8"
	case "uint16":
		return "uint16"
	case "uint32":
		return "uint32"
	case "uint64":
		return "uint64"
	case "int32": // should be "int", but whatever...
		return "int32"
	case "float":
		return "float64"
	case "string":
		return "string"
	case "tlv8":
		return "TLV8"
	default:
		panic("unexpected format: " + format)
	}
}
